// *****************************************************************
// *                                                               *
// *       Copyright (c) Fast Corporation, 2010                    *
// *                                                               *
// *   All Rights Reserved.  Unpublished rights  reserved  under   *
// *   the copyright laws of the Japan.                            *
// *                                                               *
// *   The software contained on this media  is  proprietary  to   *
// *   and  embodies  the  confidential  technology  of  Fast      *
// *   Corporation.  Possession, use,  duplication  or             *
// *   dissemination of the software and media is authorized only  *
// *   pursuant to a valid written license from Fast Corporation.  *
// *                                                               *
// *****************************************************************

using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

// -----------------------------------------------------------------
// FVIL Sample Program
// p^\_CAO
//
// 쐬 : N.Moriguchi
//
//  : 2010/09/28 
//
// -----------------------------------------------------------------
namespace FPM2_Search_Sample
{
    public partial class Form_PTNDISPLAY : Form
    {
        //GbW\pI[o[CNX錾
        private FVIL.GDI.CFviOverlay overlayEdge = new FVIL.GDI.CFviOverlay();
        //p^\NX
        private FVIL.Data.CFviPattern m_pattern_org;
        private FVIL.Data.CFviPattern m_pattern_temp;
        //FPM2ev[gʒoNX
        private FVIL.FPM2.CFviFPM2Template template = new FVIL.FPM2.CFviFPM2Template();

        public Form_PTNDISPLAY()
        {
            InitializeComponent();
        }

        /// <summary>
        /// tH[
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        /// <remarks>
        /// p^\tH[̏B
        /// </remarks>
        private void Form_PTNDISPLAY_Load(object sender, EventArgs e)
        {
            //p^{R{{bNX
            comboBoxPatternMag.Items.Clear();
            comboBoxPatternMag.Items.Add("1");
            comboBoxPatternMag.Items.Add("2");
            comboBoxPatternMag.Items.Add("4");
            comboBoxPatternMag.SelectedIndex = 0;

            //J[\TCYR{{bNX
            comboBoxCursorSize.Items.Clear();
            comboBoxCursorSize.Items.Add("1");
            comboBoxCursorSize.Items.Add("3");
            comboBoxCursorSize.Items.Add("5");
            comboBoxCursorSize.Items.Add("7");
            comboBoxCursorSize.Items.Add("11");
            comboBoxCursorSize.SelectedIndex = 0;

            //p^摜̕
            m_pattern_temp = (FVIL.Data.CFviPattern)m_pattern_org.Clone();
            // p^\
            cFviImageView1.Image = m_pattern_temp;
            //GbW\pI[o[C̒ǉ
            cFviImageView1.Display.Overlays.Add(overlayEdge);
            //ĕ`
            cFviImageView1.Refresh();
        }

        /// <summary>
        /// p^IuWFNg̊i[
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        /// <remarks>
        /// CtH[̃p^̎擾B
        /// </remarks>
        public void Set_pattern(FVIL.Data.CFviPattern param)
        {
            m_pattern_org = param;
        }

        /// <summary>
        /// ev[gʂ̊i[
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        /// <remarks>
        /// CtH[̃ev[gʂ̎擾B
        /// </remarks>
        public void Set_template(FVIL.FPM2.CFviFPM2Template param)
        {
            template = param;
        }

        /// <summary>
        /// GbW\`FbN{bNX
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        /// <remarks>
        /// GbW`揈B
        /// </remarks>
        private void checkBoxPtnEdgeDisplay_CheckedChanged(object sender, EventArgs e)
        {
            if (checkBoxPtnEdgeDisplay.Checked == true)
            {
                List<FVIL.Edge.CFviEdgeData> edges_image = new List<FVIL.Edge.CFviEdgeData>();
                //Ώۉ摜̃GbW_
                edges_image = (List<FVIL.Edge.CFviEdgeData>)template.GetFeatureEdges();

                //ʉ摜̕\
                for (int i = 0; i < edges_image.Count; i++)
                {
                    FVIL.Edge.CFviEdgeData edge = edges_image[i];
                    // GbWʒu  }[N\ (0x)
                    FVIL.GDI.CFviGdiPoint position = new FVIL.GDI.CFviGdiPoint(edge.Position);
                    position.Size = new System.Drawing.Size(3, 1);
                    position.Style = FVIL.GDI.FigureStyle.Arrow;
                    position.Angle = edges_image[i].Angle;
                    position.Pen.Color = System.Drawing.Color.FromArgb(0, 0xFF, 0);
                    overlayEdge.Figures.Add(position);
                }
            }
            else
            {
                overlayEdge.Figures.Clear();
            }
            //ĕ`
            cFviImageView1.Refresh();
        }

        /// <summary>
        /// I
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        /// <remarks>
        /// tH[IB
        /// </remarks>
        private void Form_PTNDISPLAY_FormClosed(object sender, FormClosedEventArgs e)
        {
            checkBoxPtnEdgeDisplay.Checked = false;
            overlayEdge.Figures.Clear();
            //ĕ`
            cFviImageView1.Refresh();
        }

        /// <summary>
        /// p^\ɕύX
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        /// <remarks>
        /// p^\[hp\ύXB
        /// </remarks>
        public void Mode_Pattern()
        {
            button_OK.Visible = false;
            button_Cancel.Text = "߂";
            groupBoxPenForm.Visible = false;
            groupBoxKindMask.Visible = false;
        }

        /// <summary>
        /// }XNݒɕύX
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        /// <remarks>
        /// }XNݒ胂[hp\ύXB
        /// </remarks>
        public void Mode_Mask()
        {
            button_OK.Visible = true;
            button_Cancel.Text = "Cancel";
            groupBoxPenForm.Visible = true;
            groupBoxKindMask.Visible = true;

            cFviImageView1.Display.MaskEnable = true;
            cFviImageView1.Display.EssentialMaskEnable = true;
            cFviImageView1.Display.OverlayPatternModify.Active = true;
        }

        /// <summary>
        /// yWI{^
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        /// <remarks>
        /// J[\yɕύXB
        /// </remarks>
        private void radioButtonModePen_CheckedChanged(object sender, EventArgs e)
        {
            cFviImageView1.Display.OverlayPatternModify.MaskCursorMode = FVIL.GDI.MaskCursorMode.Write;
        }

        /// <summary>
        /// SWI{^
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        /// <remarks>
        /// J[\SɕύXB
        /// </remarks>
        private void radioButtonModeEraser_CheckedChanged(object sender, EventArgs e)
        {
            cFviImageView1.Display.OverlayPatternModify.MaskCursorMode = FVIL.GDI.MaskCursorMode.Erase;
        }

        /// <summary>
        /// }XNWI{^
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        /// <remarks>
        /// J[\}XNҏWɕύXB
        /// </remarks>
        private void radioButtonModeMask_CheckedChanged(object sender, EventArgs e)
        {
            cFviImageView1.Display.OverlayPatternModify.MaskBit = FVIL.Data.Pattern.MaskBit.MASK;
        }

        /// <summary>
        /// sWI{^
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        /// <remarks>
        /// J[\sҏWɕύXB
        /// </remarks>
        private void radioButtonModeEssential_CheckedChanged(object sender, EventArgs e)
        {
            cFviImageView1.Display.OverlayPatternModify.MaskBit = FVIL.Data.Pattern.MaskBit.ESSENTIAL;
        }

        /// <summary>
        /// CursorSizeR{{bNX
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        /// <remarks>
        /// J[\TCYύXB
        /// </remarks>
        private void comboBoxCursorSize_SelectedIndexChanged(object sender, EventArgs e)
        {
            switch (comboBoxCursorSize.SelectedIndex)
            {
                case 0:
                    cFviImageView1.Display.OverlayPatternModify.MaskCursorSize = new Size(1, 1);
                    break;
                case 1:
                    cFviImageView1.Display.OverlayPatternModify.MaskCursorSize = new Size(3, 3);
                    break;
                case 2:
                    cFviImageView1.Display.OverlayPatternModify.MaskCursorSize = new Size(5, 5);
                    break;
                case 3:
                    cFviImageView1.Display.OverlayPatternModify.MaskCursorSize = new Size(7, 7);
                    break;
                case 4:
                    cFviImageView1.Display.OverlayPatternModify.MaskCursorSize = new Size(11, 11);
                    break;
                default:
                    cFviImageView1.Display.OverlayPatternModify.MaskCursorSize = new Size(1, 1);
                    break;
            }
        }

        /// <summary>
        /// p^\{R{{bNX
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        /// <remarks>
        /// p^摜̕\{ύXB
        /// </remarks>
        private void comboBoxPatternMag_SelectedIndexChanged(object sender, EventArgs e)
        {
            //\{̐ݒ
            switch (comboBoxPatternMag.SelectedIndex)
            {
                case 0:
                    cFviImageView1.Display.Magnification = 1.0;
                    break;
                case 1:
                    cFviImageView1.Display.Magnification = 2.0;
                    break;
                case 2:
                    cFviImageView1.Display.Magnification = 4.0;
                    break;
                default:
                    cFviImageView1.Display.Magnification = 1.0;
                    break;
            }
            //ĕ`
            cFviImageView1.Refresh();
        }

        /// <summary>
        /// OK{^
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        /// <remarks>
        /// CtH[̃p^f[^XVB
        /// </remarks>
        private void button_OK_Click(object sender, EventArgs e)
        {
            //p^f[^Rs[
            m_pattern_org.CopyFrom(m_pattern_temp);
            Close();
        }

        /// <summary>
        /// LZ{^
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        /// <remarks>
        /// p^\tH[ł̐ݒjB
        /// </remarks>
        private void button_Cancel_Click(object sender, EventArgs e)
        {
            Close();
        }

    }
}